#include "stlpconfig.h"

#include <windows.h>

#include "acbase.h"

#include "Config.h"
#include "ConfigDlg.h"
#include "AutoCreate.h"

// DllMain
BOOL WINAPI DllMain( HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved )
{
	switch ( fdwReason )
	{
	case DLL_PROCESS_ATTACH:
	case DLL_THREAD_ATTACH:
		::CoInitialize( NULL ) ;
		break ;

	case DLL_PROCESS_DETACH:
	case DLL_THREAD_DETACH:
		::CoUninitialize() ;
		break ;
	}
	return TRUE ;
}

// vOC̊T擾
LPCSTR WINAPI acGetSummary( void )
{
	return "摜̊i[tH_瑮𐶐B" ;
}

// vOC̃o[W擾
LPCSTR WINAPI acGetVersion( void )
{
	return "1.0.1.1" ;
}

// vOCݒǂݍ
AC_HCONFIG WINAPI acLoadConfig( LPCSTR pszINIFilePath )
{
	try
	{
		return new CConfig( pszINIFilePath ) ;
	}
	catch ( ... )
	{
		return NULL ;
	}
}

// RtBOnhJ
void WINAPI acReleaseConfig( AC_HCONFIG hConfig )
{
	delete static_cast<CConfig *>(hConfig) ;
}

// vOCݒۑ
void WINAPI acSaveConfig( AC_HCONFIG hConfig, LPCSTR pszINIFilePath )
{
	static_cast<CConfig *>(hConfig)->Save( pszINIFilePath ) ;
}

// vOCݒ_CAO\
void WINAPI acConfigDlg( AC_HCONFIG hConfig, HWND hParentWnd )
{
	CConfigDlg	dlg( static_cast<CConfig *>(hConfig) ) ;
	dlg.DoModal( hParentWnd ) ;
}

// vOCv摜Ԃ擾
AC_PISTATE WINAPI acGetRequireOfPIState( void )
{
	return CAutoCreate::GetRequireOfPIState() ;
}

// nh擾
AC_HAC WINAPI acGetAC( AC_PCPICTUREINFO pPictureInfo, AC_HCONFIG hConfig )
{
	try
	{
		return new CAutoCreate( pPictureInfo, static_cast<CConfig *>(hConfig) ) ;
	}
	catch ( ... )
	{
		return NULL ;
	}
}

// 擾
UINT WINAPI acGetAttNum( AC_HAC hAC )
{
	return static_cast<CAutoCreate *>(hAC)->GetAttNum() ;
}

// ̂擾
LPCSTR WINAPI acGetAttName( AC_HAC hAC, UINT index )
{
	return static_cast<CAutoCreate *>(hAC)->GetAttName( index ) ;
}

// nhJ
void WINAPI acReleaseAC( AC_HAC hAC )
{
	delete static_cast<CAutoCreate *>(hAC) ;
}





