//////////////////////////////////////////////////////////////////////////////
//	֘A֐
//////////////////////////////////////////////////////////////////////////////

#pragma once

#include <windows.h>

#include <string>

#include "Buffer.h"

// ɂ
inline void MakeLower( std::string & strText )
{
	size_t	length = strText.size() ;
	for ( size_t i = 0 ; i < length ; i ++ )
	{
		if ( ::IsDBCSLeadByte( strText[i] ) )
			i ++ ;
		else if ( strText[i] >= 'A' && strText[i] <= 'Z' )
			strText[i] = 'a' + strText[i] - 'A' ;
	}
}
inline void MakeLower( std::wstring & wstrText )
{
	size_t	length = wstrText.size() ;
	for ( size_t i = 0 ; i < length ; i ++ )
	{
		if ( wstrText[i] >= L'A' && wstrText[i] <= L'Z' )
			wstrText[i] = L'a' + wstrText[i] - L'A' ;
	}
}

// Ch쐬
inline void MakeWString( std::wstring & wstrText, LPCSTR pszText, bool bLower = false )
{
	std::string	strText( pszText ) ;
	if ( bLower )
		MakeLower( strText ) ;
	int		textLength = static_cast<int>( strText.size() ) ;
	int		length = ::MultiByteToWideChar( CP_ACP, MB_PRECOMPOSED, strText.c_str(), textLength, NULL, 0 ) ;
	CBuffer<wchar_t>	buffer( ( length + 1 ) << 1, true ) ;
	::MultiByteToWideChar( CP_ACP, MB_PRECOMPOSED, strText.c_str(), textLength, buffer, static_cast<DWORD>(buffer.size()) ) ;
	wstrText = buffer ;
}

// }`oCg쐬
inline void MakeString( std::string & strText, LPCWSTR pszText, bool bLower = false )
{
	std::wstring	wstrText( pszText ) ;
	int		textLength = static_cast<int>( wstrText.size() ) ;
	int		length = ::WideCharToMultiByte( CP_ACP, 0, wstrText.c_str(), textLength, NULL, 0, NULL, NULL ) ;
	CBuffer<char>	buffer( length + 1, true ) ;
	::WideCharToMultiByte( CP_ACP, 0, wstrText.c_str(), textLength, buffer, static_cast<DWORD>(buffer.size()), NULL, NULL ) ;
	strText = buffer ;
	if ( bLower )
		MakeLower( strText ) ;
}
