//////////////////////////////////////////////////////////////////////////////
//	obt@NX
//////////////////////////////////////////////////////////////////////////////

#pragma once

#include <stdlib.h>
#include <boost/shared_ptr.hpp>

template <typename T>
class CBuffer
{
public:
	// RXgN^
	CBuffer( size_t size, bool bInitZero = false ):
		m_buffer( static_cast<T *>( bInitZero ? ::calloc(1,size) : ::malloc(size) ), ::free ),
		m_size( size )
	{
	}

private:
	boost::shared_ptr<T>	m_buffer ;
	size_t					m_size ;

public:
	// obt@̐擪AhX擾
	operator T *( void ) const
	{
		return m_buffer.get() ;
	}
	T * get( void ) const
	{
		return m_buffer.get() ;
	}
	// obt@̃TCY擾
	size_t size( void ) const
	{
		return m_size ;
	}
} ;





