//////////////////////////////////////////////////////////////////////////////
//	vOCݒ_CAONX
//////////////////////////////////////////////////////////////////////////////

#include "stlpconfig.h"

#include "ConfigDlg.h"

#include <atlmisc.h>
#include <atlctrls.h>

#include "Buffer.h"

LRESULT CConfigDlg::OnInitDialog( UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL & /*bHandled*/ )
{
	CEdit			edit = GetDlgItem( IDC_EDIT_IGNOREWORDS ) ;
	std::string		text ;
	m_pConfig->GetEditText( text ) ;
	edit.SetWindowText( text.c_str() ) ;
	CenterWindow( GetParent() ) ;
	return TRUE;
}

LRESULT CConfigDlg::OnOk( WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL & /*bHandled*/ )
{
	CEdit			edit = GetDlgItem( IDC_EDIT_IGNOREWORDS ) ;
	CBuffer<char>	text( edit.GetWindowTextLength() + 1, true ) ;
	edit.GetWindowText( text, static_cast<int>( text.size() ) ) ;
	m_pConfig->SetEditText( text ) ;
	EndDialog( wID ) ;
	return 0 ;
}

LRESULT CConfigDlg::OnCancel( WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL & /*bHandled*/ )
{
	EndDialog( wID ) ;
	return 0 ;
}
