//////////////////////////////////////////////////////////////////////////////
//	INIt@CNX
//////////////////////////////////////////////////////////////////////////////

#pragma once

#include <windows.h>

#include <string>
#include <boost/lexical_cast.hpp>

class CIniFile
{
public:
	// RXgN^
	CIniFile( LPCSTR pszINIFilePath ):
		m_iniFilePath( pszINIFilePath )
	{
	}

private:
	std::string		m_iniFilePath ;

public:
	// l擾
	template <typename T>
		T Get( LPCSTR pszSection, LPCSTR pszKey, T defVal )
	{
		std::string	strDefVal = boost::lexical_cast<std::string>( defVal ) ;
		const DWORD	c_bufferSize = 512 ;
		char		buffer[c_bufferSize] ;
		::GetPrivateProfileString( pszSection, pszKey, strDefVal.c_str(), buffer, c_bufferSize, m_iniFilePath.c_str() ) ;
		return boost::lexical_cast<T>( buffer ) ;
	}
	// lݒ肷
	template <typename T>
		void Set( LPCSTR pszSection, LPCSTR pszKey, T val )
	{
		std::string	strVal = boost::lexical_cast<std::string>( val ) ;
		if ( !strVal.empty() )
		{
			if ( strVal[0] == '\"' || strVal[0] == ' ' || strVal[strVal.size()-1] == ' ' )
			{
				strVal.insert( strVal.begin(), 1, '\"' ) ;
				strVal += "\"" ;
			}
		}
		::WritePrivateProfileString( pszSection, pszKey, strVal.c_str(), m_iniFilePath.c_str() ) ;
	}
} ;
